package io.fabric8.kubernetes.api.model;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.api.Assertions;


import io.fabric8.kubernetes.assertions.AssertFactory;
import io.fabric8.kubernetes.assertions.NavigationListAssert;

import static org.assertj.core.api.Assertions.assertThat;
import static io.fabric8.kubernetes.assertions.internal.Assertions.assertThat;
import static io.fabric8.openshift.assertions.Assertions.assertThat;

/**
 * Abstract base class for {@link EnvVar} specific assertions - Generated by CustomAssertionGenerator.
 */
public abstract class AbstractEnvVarAssert<S extends AbstractEnvVarAssert<S, A>, A extends EnvVar> extends AbstractAssert<S, A> {

  /**
   * Creates a new <code>{@link AbstractEnvVarAssert}</code> to make assertions on actual EnvVar.
   * @param actual the EnvVar we want to make assertions on.
   */
  protected AbstractEnvVarAssert(A actual, Class<S> selfType) {
    super(actual, selfType);
  }


  /**
   * Navigates to the property additionalProperties so that assertions can be done on it
   */
  public org.assertj.core.api.MapAssert additionalProperties()  {
    // check that actual EnvVar we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.MapAssert) assertThat(actual.getAdditionalProperties()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "additionalProperties"));
  }


  /**
   * Navigates to the property name so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert name()  {
    // check that actual EnvVar we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getName()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "name"));
  }


  /**
   * Navigates to the property value so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert value()  {
    // check that actual EnvVar we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getValue()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "value"));
  }


  /**
   * Navigates to the property valueFrom so that assertions can be done on it
   */
  public EnvVarSourceAssert valueFrom()  {
    // check that actual EnvVar we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (EnvVarSourceAssert) assertThat(actual.getValueFrom()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "valueFrom"));
  }


}
